# -*- coding: utf-8 -*-
import sys
from PyQt5.QtCore import *
from PyQt5.QtWidgets import *
from PyQt5.QtGui import *
 
class Child(QWidget):
    # Создали сигнал
    # Указали, что возвращаем список
    signal = pyqtSignal(list)
    
    def __init__(self, parent = None):
        super().__init__(parent)
        self.line = QLineEdit()
        self.box = QSpinBox()
        self.button = QPushButton('Отправить')
        self.button.clicked.connect(self.hello)
        grid = QGridLayout(self)
        grid.addWidget(self.line)
        grid.addWidget(self.box)
        grid.addWidget(self.button)
    
    def hello(self):
        # Отправляем сигнал
        self.signal.emit([self.box.value(),self.line.text()])

class Example(QMainWindow):
    def __init__(self, parent=None):
        super().__init__(parent)
        self.mdi = QMdiArea()
        self.setCentralWidget(self.mdi)
        bar = self.menuBar()
        stBar = self.statusBar()
        self.count = 0
       
        file = bar.addMenu("File")
        file.addAction("New")
        file.addAction("Cascade")
        file.addAction("Tiled")
        file.triggered[QAction].connect(self.windowaction)
        self.setWindowTitle("MDI demo")

        # ======== Значок в области уведомлений
        ico = QIcon('super_m.png')
        ic = QSystemTrayIcon(ico)
        ic.setToolTip ('Пример значка')
        ic.show()
        ic.setVisible(True)
    		
    def on_child(self, value):
        # Вывод отправленных значений в строку состояния
        s = '1-й параметр: ' + str(value[0]) + ', 2-й параметр: ' + str(value[1])
        self.statusBar().showMessage(s)

    def windowaction(self, q):
        if q.text() == "New":
            self.count = self.count + 1
            # Создаем объект дочернего окна
            sub = QMdiSubWindow()
            # Создаем дочерний виджет
            child = Child()
            # Связываем сигнал с обработчиком
            child.signal.connect(self.on_child)
            # Помещаем созданный дочерний виджет в окно
            sub.setWidget(child)
            sub.setWindowTitle("subwindow" + str(self.count))
            # Добавляем дочернее окно к MDI-приложению
            self.mdi.addSubWindow(sub)
            # Показываем дочернее окно
            sub.show()
        if q.text() == "Cascade":
            self.mdi.cascadeSubWindows()
        if q.text() == "Tiled":
            self.mdi.tileSubWindows()


if __name__ == '__main__':
    app = QApplication(sys.argv)
    ex = Example()
    ex.show()
    sys.exit(app.exec_())
